package nl.amis.ejb30.als;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;


public class LibraryService {
    public LibraryService() {
        EntityManagerFactory emf = 
            Persistence.createEntityManagerFactory("AlsPU");
        // create EntityManager
        EntityManager em = emf.createEntityManager();
        // note: alternative is EXTENDED EntityManager ; an EXTENDED EntityManager keeps objects attached
        // EntityManager em = emf.createEntityManager(PersistenceContextType.EXTENDED);
        this.setEntityManager(em);
    }

    private EntityManager _entityManager;

    public EntityManager getEntityManager() {
        return _entityManager;
    }

    public void setEntityManager(EntityManager entityManager) {
        _entityManager = entityManager;
    }

    public List<Publisher> findAllPublishers() {
        return getEntityManager().createQuery("select object(o) from Publisher o").getResultList();
    }

    public Publisher findPublisher(Long id) {
        return getEntityManager().find(Publisher.class, id);
    }

    public List<Author> findAllAuthors() {
        return getEntityManager().createQuery("select object(o) from Author o").getResultList();
    }

    public Author findAuthor(Long id) {
        return getEntityManager().find(Author.class, id);
    }
}
