package nl.amis.ejb30.als;

import java.io.Serializable;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.Table;


@Entity
@Table(name="ALS_AUTHORS")
public class Author implements Serializable {

    private String firstName;

    private Long id;

    private String lastName;
    
    private Collection<Book> books;

    public Author() {
    }

    public Author(Long id) {
        this.id = id;
    }

    @ManyToMany(cascade=CascadeType.ALL)
    @JoinTable(table = @Table(name = "als_authorships"), joinColumns = {
           @JoinColumn(name = "atr_id")
       }, inverseJoinColumns = {
           @JoinColumn(name = "bok_id")
       })
    public Collection<Book> getBooks() {
        return this.books;
    }
    
    public void setBooks(Collection<Book> books) {
        this.books = books;
    }


    @Column(name="FIRST_NAME")
    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    @Id
    @Column(name="ID", nullable=false)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }


    @Column(name="LAST_NAME")
    public String getLastName() {
        return lastName;
    }

    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

}
