package nl.amis.ejb30.als;

import java.io.Serializable;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import static javax.persistence.GeneratorType.SEQUENCE;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Version;


@Entity
@Table(name="ALS_PUBLISHERS")
public class Publisher implements Serializable {

    private Long id;

    private String locationInCountry;

    private byte[] logo;

    private String name;

    private String website;
    private Long version;
    private Collection<Book> bookCollection;

    @OneToMany(cascade={CascadeType.ALL})
    @JoinTable(table = @Table(name = "ALS_BOOKS"), joinColumns = {
            @JoinColumn(name = "pbr_id")
        })
    public Collection<Book> getBookCollection() {
        return bookCollection;
    }

    public void setBookCollection(Collection<Book> bookCollection) {
        this.bookCollection = bookCollection;
    }


    public Publisher() {
    }

    public Publisher(Long id) {
        this.id = id;
    }

    @Id(generate=SEQUENCE,generator="ALS_PBR_SEQ")
    @SequenceGenerator(name="LEAGUE_SEQ_GEN", sequenceName="LEAGUE_SEQ",initialValue=15,allocationSize=1)     
    @Column(name="ID",  nullable=false)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Column(name="LOCATION_IN_COUNTRY")
    public String getLocationInCountry() {
        return locationInCountry;
    }

    public void setLocationInCountry(String locationInCountry) {
        this.locationInCountry = locationInCountry;
    }

    @Column(name="NAME")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Column(name="WEBSITE")
    public String getWebsite() {
        return website;
    }

    public void setWebsite(String website) {
        this.website = website;
    }

    public void setVersion(Long version) {
        this.version = version;
    }

    @Version
    @Column
    public Long getVersion() {
        return version;
    }
}
