package nl.amis.ejb30.als;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQuery;
import javax.persistence.Table;


@Entity
@Table(name="ALS_BOOKS")

@NamedQuery(name="javaBooks", 
  queryString="select object(o) from Book o where lower(o.title) like '%java%' ")
public class Book {
    private Long id;
    private String isbn;
    private Long publishYear;
    private String title;
    private Publisher publisher;
    
    private Collection<Author> authors;

    @ManyToMany(cascade=CascadeType.ALL)
    @JoinTable(table = @Table(name = "als_authorships"), joinColumns = {
           @JoinColumn(name = "bok_id")
       }, inverseJoinColumns = {
           @JoinColumn(name = "atr_id")
       })
public Collection<Author> getAuthors() {
        return this.authors;
    }
    
    public void setAuthors(Collection<Author> authors) {
        this.authors = authors;
    }

    
    public void setPublisher(Publisher publisher) {
        this.publisher = publisher;
    }

    @ManyToOne(optional=false)
      @JoinColumn(name="pbr_id")    
    public Publisher getPublisher() {
        return publisher;
    }


    public Book() {
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Id
    @Column(name="ID", nullable=false)
    public Long getId() {
        return id;
    }

    public void setIsbn(String isbn) {
        this.isbn = isbn;
    }

    @Column(name="ISBN")
    public String getIsbn() {
        return isbn;
    }

    public void setPublishYear(Long publishYear) {
        this.publishYear = publishYear;
    }

    @Column(name="PUBLISH_YEAR")
    public Long getPublishYear() {
        return publishYear;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    @Column(name="TITLE", nullable=false)
    public String getTitle() {
        return title;
    }

}
