package nl.amis.ejb30.als;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

public class LibraryClient {
    public LibraryClient() {
    }

    public static void main(String[] args) {
        LibraryService library = new LibraryService();


        System.out.println("Summary of all books:");
        Object[] summary = (Object[])library.findBookSummary();
        System.out.println("Most recent book is from "+summary[0]);
        System.out.println("Oldest book is from "+summary[1]);
        System.out.println("There are "+summary[2]+" books altogether.");
        


        System.out.println("Find all books written by Steve:");
        for (Book book : library.findStevesBooks()) { 
          System.out.println(book.getTitle()+ " published in "+book.getPublishYear());
          for (Author author: book.getAuthors()) {
              System.out.println(" * "+ author.getFirstName()+ " " + author.getLastName());
          }
        }  


        System.out.println("List all Books on XML:");
        for (Book book : library.findAllBooksOnSubject("xml")) { 
          System.out.println(book.getTitle()+ " published by "+book.getPublisher().getName());
          for (Author author: book.getAuthors()) {
              System.out.println(" * "+ author.getFirstName()+ " " + author.getLastName());
          }
        } 
        
        System.out.println("That's all on XML, folks!");

        System.out.println("List all Publishers that have published a book for an author who has written a book with oracle in its name:");
        Collection publishers = library.findJavaPublishers();
        for (Iterator iterator = publishers.iterator(); iterator.hasNext(); ){
           Object[] resultElement = (Object[])iterator.next();
           Publisher publisher = (Publisher)resultElement[0];
           System.out.println(publisher.getName());
           Author author = (Author)resultElement[1];
           System.out.println(author.getLastName());
        }        

        System.out.println("Most recent book for each Publisher:");
        for (Book book : library.findRecentBooks()) { 
          System.out.println(book.getTitle()+ " published in "+book.getPublishYear());
          for (Author author: book.getAuthors()) {
              System.out.println(" * "+ author.getFirstName()+ " " + author.getLastName());
          }
        }  

    }
}
